library(repeated)

y <- scan("dna5.dat",what=character(0),skip=6)
data <- NULL
for(i in 1:length(y))data <- c(data,unlist(strsplit(y[i],split=NULL)))
y <- rbind(c(codes(as.factor(data[1:1046])),rep(1,38)),
	c(codes(as.factor(data[1047:2092])),rep(1,38)),
	codes(as.factor(data[2093:3176])),codes(as.factor(data[3177:4260])))
for(i in 1:4)y[i,] <- ifelse(y[i,]==1,NA,y[i,]-2)

intron <- c(356:472,678:820)
exon <- c(261:355,473:677,821:949)
yexon <- restovec(y[,exon])
yintron <- restovec(y[,intron])

mu1b <- function(p) array(rep(p,rep(4,3)),c(4,1,3))
mu2b <- function(p) array(rep(p,rep(4,6)),c(4,2,3))
mu3b <- function(p) array(rep(p,rep(4,9)),c(4,3,3))
mu4b <- function(p) array(rep(p,rep(4,12)),c(4,4,3))
mu5b <- function(p) array(rep(p,rep(4,15)),c(4,5,3))
mu6b <- function(p) array(rep(p,rep(4,18)),c(4,6,3))

yy <- as.numeric(c(t(y[,exon])==1,t(y[,exon])==2,t(y[,exon])==3,
	t(y[,exon])==4))
state <- gl(4,1716)
state1 <- as.factor(c(1,rep(t(y[,exon]-1),4)[1:6863]))
pos <- gl(3,1,6864)
wt <- rep(1,6864)
wt[seq(1,6864,by=429)] <- 0
print(z <- glm(yy~state,family=poisson,weight=wt))
-sum(yy*log(z$fit))
-sum(wt*yy*log(z$fit))-2*log(sum(wt[1:1716]*z$fit[1:1716])/1716)
print(z <- glm(yy~state*pos,family=poisson,weight=wt))
-sum(yy*log(z$fit))
-sum(wt*yy*log(z$fit))-2*log(sum(wt[1:1716]*z$fit[1:1716])/1716)
print(z <- glm(yy~state*state1,family=poisson,weight=wt))
-sum(yy*log(z$fit))
-sum(wt*yy*log(z$fit))-2*log(sum(wt[1:1716]*z$fit[1:1716])/1716)
# the following requires -v15
#print(z <- glm(yy~state*state1+state*pos,family=poisson,weight=wt))
#-sum(yy*log(z$fit))
#-sum(wt*yy*log(z$fit))-2*log(sum(wt[1:1716]*z$fit[1:1716])/1716)

yy <- as.numeric(c(t(y[,intron])==1,t(y[,intron])==2,t(y[,intron])==3,
	t(y[,intron])==4))
state <- gl(4,1040)
state1 <- as.factor(c(1,rep(t(y[,intron]-1),4)[1:4159]))
wt <- rep(1,4160)
wt[seq(1,4160,by=260)] <- 0
print(z <- glm(yy~state,family=poisson,weight=wt))
-sum(yy[!is.na(yy)]*log(z$fit))
-sum(wt[!is.na(yy)]*yy[!is.na(yy)]*log(z$fit))-2*log(sum(wt[2081:3120]*z$fit[2081:3120])/1040)
print(z <- glm(yy~state*state1,family=poisson,weight=wt))
-sum(yy[!is.na(yy)&!is.na(state1)]*log(z$fit))
-sum(wt[!is.na(yy)&!is.na(state1)]*yy[!is.na(yy)&!is.na(state1)]*log(z$fit))-2*log(sum(wt[2081:3120]*z$fit[2081:3120])/1040)
rm(pos,wt,state,state1,yy)

sum(as.vector(y[,exon])==1)/1716
sum(as.vector(y[,exon])==2)/1716
sum(as.vector(y[,exon])==3)/1716
sum(as.vector(y[,exon])==4)/1716
sum(as.vector(y[,intron])==1,na.rm=T)/1040
sum(as.vector(y[,intron])==2,na.rm=T)/1040
sum(as.vector(y[,intron])==3,na.rm=T)/1040
sum(as.vector(y[,intron])==4,na.rm=T)/1040

print(z <- hidden(yintron,dist="mult",pgamma=1,
	cmu=mu1b,pcmu=rep(1,3),iter=200))
c(1,exp(z$coef[1:3]))/(1+sum(exp(z$coef[1:3])))

print(z <- hidden(yexon,dist="mult",pgamma=1,
	cmu=mu1b,pcmu=rep(1,3),iter=200))
c(1,exp(z$coef[1:3]))/(1+sum(exp(z$coef[1:3])))

print(z <- hidden(yintron,dist="mult",
	pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,byrow=T),
	cmu=mu2b,pcmu=rep(1,6),iter=200))
c(1,exp(z$coef[seq(1,6,by=2)]))/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(1,exp(z$coef[seq(2,6,by=2)]))/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=mu2b,pcmu=rep(1,6),iter=200))
c(1,exp(z$coef[seq(1,6,by=2)]))/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(1,exp(z$coef[seq(2,6,by=2)]))/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(yintron,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3b,pcmu=rep(1,9),iter=200))
c(1,exp(z$coef[seq(1,9,by=3)]))/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(1,exp(z$coef[seq(2,9,by=3)]))/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(1,exp(z$coef[seq(3,9,by=3)]))/(1+sum(exp(z$coef[seq(3,9,by=3)])))

mu3c <- function(p) array(rep(c(p[1],-30,p[2:3],-30,p[4],-30,30,p[5]),rep(4,9)),c(4,3,3))
print(z <- hidden(yintron,dist="mult",
	pgamma=matrix(c(0.3,0.7,0,0.5,0.4,0.1,0.4,0,0.6),ncol=3,byrow=T),
	cmu=mu3c,pcmu=rep(1,5),iter=200))

print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3b,pcmu=rep(1,9),iter=200))
c(1,exp(z$coef[seq(1,9,by=3)]))/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(1,exp(z$coef[seq(2,9,by=3)]))/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(1,exp(z$coef[seq(3,9,by=3)]))/(1+sum(exp(z$coef[seq(3,9,by=3)])))

tran <- matrix(0.2,ncol=4,nrow=4)
diag(tran) <- 0.3
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- 0.3
print(z <- hidden(yintron,dist="mult",pgamma=tran,
	cmu=mu4b,pcmu=rep(1,12),iter=200))
c(1,exp(z$coef[seq(1,12,by=4)]))/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(1,exp(z$coef[seq(2,12,by=4)]))/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(1,exp(z$coef[seq(3,12,by=4)]))/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(1,exp(z$coef[seq(4,12,by=4)]))/(1+sum(exp(z$coef[seq(4,12,by=4)])))

print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu4b,pcmu=rep(-1,12),iter=200))
c(1,exp(z$coef[seq(1,12,by=4)]))/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(1,exp(z$coef[seq(2,12,by=4)]))/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(1,exp(z$coef[seq(3,12,by=4)]))/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(1,exp(z$coef[seq(4,12,by=4)]))/(1+sum(exp(z$coef[seq(4,12,by=4)])))

tran <- matrix(c(0,0,0,1,0.8,0.2,0,0,0,0.2,0.4,0.4,0,0.2,0.5,0.3),
	ncol=4,byrow=T)
mu4c <- function(p) array(rep(c(-30,-30,p[1:2],-30,p[3:4],-30,-30,p[5],-30,p[6]),rep(4,12)),c(4,4,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu4c,pcmu=rep(-1,6),iter=200))

tran <- matrix(0.2,ncol=5,nrow=5)
diag(tran) <- 0.3
tran[1,2] <- tran[2,3] <- tran[3,2] <- tran[4,2] <- tran[5,2] <- 0.1
print(z <- hidden(yintron,dist="mult",pgamma=tran,
	cmu=mu5b,pcmu=rep(-1,15),iter=200))
c(1,exp(z$coef[seq(1,15,by=5)]))/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(1,exp(z$coef[seq(2,15,by=5)]))/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(1,exp(z$coef[seq(3,15,by=5)]))/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(1,exp(z$coef[seq(4,15,by=5)]))/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(1,exp(z$coef[seq(5,15,by=5)]))/(1+sum(exp(z$coef[seq(5,15,by=5)])))

print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu5b,pcmu=rep(-1,15),iter=200))
c(1,exp(z$coef[seq(1,15,by=5)]))/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(1,exp(z$coef[seq(2,15,by=5)]))/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(1,exp(z$coef[seq(3,15,by=5)]))/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(1,exp(z$coef[seq(4,15,by=5)]))/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(1,exp(z$coef[seq(5,15,by=5)]))/(1+sum(exp(z$coef[seq(5,15,by=5)])))

tran <- matrix(c(0.19,0,0.6,0.06,0.15,
	0.07,0,0,0.38,0.55,
	0.17,0.2,0.48,0,0.15,
	0.52,0,0,0.25,0.23,
	0.12,0,0.85,0,0.03),ncol=5,byrow=T)
mu5c <- function(p) array(rep(c(p[1],-46,-9,-20,-33,-6,p[2:3],
	-0.6,-62,-35,-79,p[4],37,p[5]),rep(4,15)),c(4,5,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu5c,pcmu=c(4,-2,10,10,0.2),iter=200))

tran <- matrix(0.15,ncol=6,nrow=6)
diag(tran) <- 0.25
tran[1,1] <- 0.2
tran[1,2] <- 0.2
print(z <- hidden(yintron,dist="mult",pgamma=tran,
	cmu=mu6b,pcmu=rep(-1,18),iter=200))
c(1,exp(z$coef[seq(1,18,by=6)]))/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(1,exp(z$coef[seq(2,18,by=6)]))/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(1,exp(z$coef[seq(3,18,by=6)]))/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(1,exp(z$coef[seq(4,18,by=6)]))/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(1,exp(z$coef[seq(5,18,by=6)]))/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(1,exp(z$coef[seq(6,18,by=6)]))/(1+sum(exp(z$coef[seq(6,18,by=6)])))

tran <- matrix(0.1,ncol=6,nrow=6)
diag(tran) <- 0.2
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- tran[5,1] <- 
	  tran[6,2] <- 0.4
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu6b,pcmu=rep(1,18),iter=200))
c(1,exp(z$coef[seq(1,18,by=6)]))/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(1,exp(z$coef[seq(2,18,by=6)]))/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(1,exp(z$coef[seq(3,18,by=6)]))/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(1,exp(z$coef[seq(4,18,by=6)]))/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(1,exp(z$coef[seq(5,18,by=6)]))/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(1,exp(z$coef[seq(6,18,by=6)]))/(1+sum(exp(z$coef[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0.09,0.56,0,0,0.35,
	0,0.14,0,0.26,0.6,0,
	0.02,0.75,0,0.04,0,0.19,
	0.09,0.65,0,0,0.03,0.23,
	0.19,0,0.11,0.57,0.02,0.11),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(4,18)),c(4,6,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0.02,0.72,0,0.05,0,0.21,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(4,18)),c(4,6,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(4,18)),c(4,6,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,-30,-30,p[1],-30,p[2:3],30,-30,
	p[4],-30,p[5:6],-30,30,p[7]),rep(4,18)),c(4,6,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,-30,z$coef[1],-30,z$coef[2:3],30,-30,
	z$coef[4],-30,z$coef[5:6],-30,30,z$coef[7])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

# model from haemoglobin (dna4.r)
tran <- matrix(c(0.22,0.08,0,0.6,0,0.1,
	0,0.3,0.18,0,0.24,0.28,
	0,0.47,0,0.27,0.11,0.15,
	0,0.12,0.42,0,0.46,0,
	0.4,0,0.6,0,0,0,
	0.16,0.3,0.25,0,0,0.29),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,30,-30,p[1],-30,-30,p[2],-30,
	-30,p[3],-30,-30,p[4],-30,30,-30),rep(4,18)),c(4,6,3))
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,4),iter=200))
p <- c(30,-30,-30,30,-30,z$coef[1],-30,-30,z$coef[2],-30,
	-30,z$coef[3],-30,-30,z$coef[4],-30,30,-30)
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6a <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(1,18)),c(1,6,3))
print(z <- hidden(y[1,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

print(z <- hidden(y[2,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

print(z <- hidden(y[3,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

print(z <- hidden(y[4,exon,drop=F],dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6aa <- function(p) array(rep(c(30,-30,-30,-30,-30,p[1],-30,p[2:3],30,-30,
	p[4],-30,p[5:6],-30,p[7:8]),rep(2,18)),c(2,6,3))
print(z <- hidden(y[1:2,exon],dist="mult",pgamma=tran,
	cmu=mu6aa,pcmu=rep(0,8),iter=200))
p <- c(30,-30,-30,-30,-30,z$coef[1],-30,z$coef[2:3],30,-30,
	z$coef[4],-30,z$coef[5:6],-30,z$coef[7:8])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

tran <- matrix(c(0,0,0,0,1,0,
	0,0,0.67,0,0,0.33,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6ab <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(2,18)),c(2,6,3))
print(z <- hidden(y[3:4,exon],dist="mult",pgamma=tran,
	cmu=mu6ab,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

# by triplets
sum(as.vector(y[,exon])[seq(1,1716,by=3)]==1)/572
sum(as.vector(y[,exon])[seq(1,1716,by=3)]==2)/572
sum(as.vector(y[,exon])[seq(1,1716,by=3)]==3)/572
sum(as.vector(y[,exon])[seq(1,1716,by=3)]==4)/572
sum(as.vector(y[,exon])[seq(2,1716,by=3)]==1)/572
sum(as.vector(y[,exon])[seq(2,1716,by=3)]==2)/572
sum(as.vector(y[,exon])[seq(2,1716,by=3)]==3)/572
sum(as.vector(y[,exon])[seq(2,1716,by=3)]==4)/572
sum(as.vector(y[,exon])[seq(3,1716,by=3)]==1)/572
sum(as.vector(y[,exon])[seq(3,1716,by=3)]==2)/572
sum(as.vector(y[,exon])[seq(3,1716,by=3)]==3)/572
sum(as.vector(y[,exon])[seq(3,1716,by=3)]==4)/572

mu2tv <- function(p) array(c(rep(p[1:3],143),
      rep(p[4:6],143),
      rep(p[7:9],143),
      rep(p[10:12],143),
      rep(p[13:15],143),
      rep(p[16:18],143)),c(429,2,3))
print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),tvmu=mu2tv,ptvmu=rep(0,18),iter=200))
p <- z$coef
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))

c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))

c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

mu2tvc <- function(p) array(c(rep(p[1:3],143),
      rep(c(p[4:5],-30),143),
      rep(p[6:8],143),
      rep(c(p[9],-30,-30),143),
      rep(c(p[10:11],-30),143),
      rep(c(p[12],-30,30),143)),c(429,2,3))
print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.74,0.26,0.37,0.63),
	ncol=2,byrow=T),tvmu=mu2tvc,ptvmu=rep(0,12),iter=200))
p <- c(z$coef[1:5],-30,z$coef[6:9],-30,-30,z$coef[10:11],-30,z$coef[12],-30,30)
c(1,exp(p[seq(1,18,by=6)]))/(1+sum(exp(p[seq(1,18,by=6)])))
c(1,exp(p[seq(4,18,by=6)]))/(1+sum(exp(p[seq(4,18,by=6)])))

c(1,exp(p[seq(2,18,by=6)]))/(1+sum(exp(p[seq(2,18,by=6)])))
c(1,exp(p[seq(5,18,by=6)]))/(1+sum(exp(p[seq(5,18,by=6)])))

c(1,exp(p[seq(3,18,by=6)]))/(1+sum(exp(p[seq(3,18,by=6)])))
c(1,exp(p[seq(6,18,by=6)]))/(1+sum(exp(p[seq(6,18,by=6)])))

mu3tv <- function(p) array(c(rep(p[1:3],143),
	rep(p[4:6],143),
	rep(p[7:9],143),
	rep(p[10:12],143),
	rep(p[13:15],143),
	rep(p[16:18],143),
	rep(p[19:21],143),
	rep(p[22:24],143),
	rep(p[25:27],143)),c(429,3,3))
print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),tvmu=mu3tv,ptvmu=rep(0,27),iter=200))
p <- z$coef
c(1,exp(p[seq(1,27,by=9)]))/(1+sum(exp(p[seq(1,27,by=9)])))
c(1,exp(p[seq(4,27,by=9)]))/(1+sum(exp(p[seq(4,27,by=9)])))
c(1,exp(p[seq(7,27,by=9)]))/(1+sum(exp(p[seq(7,27,by=9)])))

c(1,exp(p[seq(2,27,by=9)]))/(1+sum(exp(p[seq(2,27,by=9)])))
c(1,exp(p[seq(5,27,by=9)]))/(1+sum(exp(p[seq(5,27,by=9)])))
c(1,exp(p[seq(8,27,by=9)]))/(1+sum(exp(p[seq(8,27,by=9)])))

c(1,exp(p[seq(3,27,by=9)]))/(1+sum(exp(p[seq(3,27,by=9)])))
c(1,exp(p[seq(6,27,by=9)]))/(1+sum(exp(p[seq(6,27,by=9)])))
c(1,exp(p[seq(9,27,by=9)]))/(1+sum(exp(p[seq(9,27,by=9)])))
mu3tvc <- function(p) array(c(rep(c(p[1:2],-30),143),
      rep(p[3:5],143),
      rep(c(-30,-30,p[6]),143),
      rep(c(-30,p[7],-30),143),
      rep(p[8:10],143),
      rep(c(30,p[11:12]),143),
      rep(c(p[13:14],30),143),
      rep(p[15:17],143),
      rep(c(-30,-30,p[18]),143)),c(429,3,3))
print(z <- hidden(yexon,dist="mult",pgamma=matrix(c(0.36,0.59,0.05,0.07,
	0.66,0.27,0.43,0.07,0.5),ncol=3,byrow=T),tvmu=mu3tvc,
	ptvmu=rep(0,18),iter=200))
p <- c(z$coef[1:2],-30,z$coef[3:5],-30,-30,z$coef[6],-30,z$coef[7],-30,
	z$coef[8:10],30,z$coef[11:14],30,z$coef[15:17],-30,-30,z$coef[18])
c(1,exp(p[seq(1,27,by=9)]))/(1+sum(exp(p[seq(1,27,by=9)])))
c(1,exp(p[seq(4,27,by=9)]))/(1+sum(exp(p[seq(4,27,by=9)])))
c(1,exp(p[seq(7,27,by=9)]))/(1+sum(exp(p[seq(7,27,by=9)])))

c(1,exp(p[seq(2,27,by=9)]))/(1+sum(exp(p[seq(2,27,by=9)])))
c(1,exp(p[seq(5,27,by=9)]))/(1+sum(exp(p[seq(5,27,by=9)])))
c(1,exp(p[seq(8,27,by=9)]))/(1+sum(exp(p[seq(8,27,by=9)])))

c(1,exp(p[seq(3,27,by=9)]))/(1+sum(exp(p[seq(3,27,by=9)])))
c(1,exp(p[seq(6,27,by=9)]))/(1+sum(exp(p[seq(6,27,by=9)])))
c(1,exp(p[seq(9,27,by=9)]))/(1+sum(exp(p[seq(9,27,by=9)])))

mu4tv <- function(p) array(c(rep(p[1:3],143),
      rep(p[4:6],143),
      rep(p[7:9],143),
      rep(p[10:12],143),
      rep(p[13:15],143),
      rep(p[16:18],143),
      rep(p[19:21],143),
      rep(p[22:24],143),
      rep(p[25:27],143),
      rep(p[28:30],143),
      rep(p[31:33],143),
      rep(p[34:36],143)),c(429,4,3))
tran <- matrix(0.2,ncol=4,nrow=4)
diag(tran) <- 0.3
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- 0.3
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	tvmu=mu4tv,ptvmu=rep(0,36),iter=200))
p <- c(z$coef)
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))
mu4tvc <- function(p) array(c(rep(c(-30,-30,p[1]),143),
      rep(p[2:4],143),
      rep(c(p[5],-30,p[6]),143),
      rep(c(-30,p[7:8]),143),
      rep(c(-30,p[9:10]),143),
      rep(c(-30,-30,-30),143),
      rep(p[11:13],143),
      rep(p[14:16],143),
      rep(p[17:19],143),
      rep(c(p[20],-30,p[21]),143),
      rep(c(-30,p[22:23]),143),
      rep(c(p[24],-30,-30),143)),c(429,4,3))
tran <- matrix(c(0,0,0.3,0.7,
	0.63,0.34,0,0.03,
	0.12,0.36,0.52,0,
	0.31,0.03,0.35,0.31),ncol=4,byrow=T)
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,24),iter=200))
p <- c(-30,-30,z$coef[1:5],-30,z$coef[6],-30,z$coef[7:8],-30,z$coef[9:10],
	-30,-30,-30,z$coef[11:20],-30,z$coef[21],-30,,z$coef[22:24],-30,-30)
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))
# from dna6.r: beta-haemoglobin
mu4tvc <- function(p) array(c(rep(c(p[1:3]),143),
      rep(c(-30,p[4:5]),143),
      rep(c(-30,-30,-30),143),
      rep(c(-30,p[6:7]),143),
      rep(c(-30,p[8:9]),143),
      rep(c(p[10:11],-30),143),
      rep(c(p[12],-30,-30),143),
      rep(c(p[13],-30,-30),143),
      rep(c(p[14:15],-30),143),
      rep(c(p[16],-30,p[17]),143),
      rep(c(p[18],-30,30),143),
      rep(c(p[19:20],-30),143)),c(429,4,3))
tran <- matrix(c(0.45,0,0.03,0.52,
	0.65,0.13,0,0.22,
	0,0.36,0.58,0.06,
	0.16,0.57,0.22,0.05),ncol=4,byrow=T)
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,20),iter=200))
p <- c(z$coef[1:3],-30,z$coef[4:5],-30,-30,-30,-30,z$coef[6:7],-30,
	z$coef[8:11],-30,z$coef[12],-30,-30,z$coef[13],-30,-30,z$coef[14:15],
	-30,z$coef[16],-30,z$coef[17:18],-30,30,z$coef[19:20],-30)
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))

mu5tv <- function(p) array(c(rep(p[1:3],143),
      rep(p[4:6],143),
      rep(p[7:9],143),
      rep(p[10:12],143),
      rep(p[13:15],143),
      rep(p[16:18],143),
      rep(p[19:21],143),
      rep(p[22:24],143),
      rep(p[25:27],143),
      rep(p[28:30],143),
      rep(p[31:33],143),
      rep(p[34:36],143),
      rep(p[37:39],143),
      rep(p[40:42],143),
      rep(p[43:45],143)),c(429,5,3))
tran <- matrix(0.2,ncol=5,nrow=5)
diag(tran) <- 0.3
tran[1,2] <- tran[2,3] <- tran[3,2] <- tran[4,2] <- tran[5,2] <- 0.1
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	tvmu=mu5tv,ptvmu=rep(0,45),iter=200))
p <- c(z$coef)
c(1,exp(p[seq(1,45,by=15)]))/(1+sum(exp(p[seq(1,45,by=15)])))
c(1,exp(p[seq(4,45,by=15)]))/(1+sum(exp(p[seq(4,45,by=15)])))
c(1,exp(p[seq(7,45,by=15)]))/(1+sum(exp(p[seq(7,45,by=15)])))
c(1,exp(p[seq(10,45,by=15)]))/(1+sum(exp(p[seq(10,45,by=15)])))
c(1,exp(p[seq(13,45,by=15)]))/(1+sum(exp(p[seq(13,45,by=15)])))

c(1,exp(p[seq(2,45,by=15)]))/(1+sum(exp(p[seq(2,45,by=15)])))
c(1,exp(p[seq(5,45,by=15)]))/(1+sum(exp(p[seq(5,45,by=15)])))
c(1,exp(p[seq(8,45,by=15)]))/(1+sum(exp(p[seq(8,45,by=15)])))
c(1,exp(p[seq(11,45,by=15)]))/(1+sum(exp(p[seq(11,45,by=15)])))
c(1,exp(p[seq(14,45,by=15)]))/(1+sum(exp(p[seq(14,45,by=15)])))

c(1,exp(p[seq(3,45,by=15)]))/(1+sum(exp(p[seq(3,45,by=15)])))
c(1,exp(p[seq(6,45,by=15)]))/(1+sum(exp(p[seq(6,45,by=15)])))
c(1,exp(p[seq(9,45,by=15)]))/(1+sum(exp(p[seq(9,45,by=15)])))
c(1,exp(p[seq(12,45,by=15)]))/(1+sum(exp(p[seq(12,45,by=15)])))
c(1,exp(p[seq(15,45,by=15)]))/(1+sum(exp(p[seq(15,45,by=15)])))
mu4tvc <- function(p) array(c(rep(c(p[1:2],-30),143),
      rep(p[3:5],143),
      rep(c(p[6],-30,-30),143),
      rep(c(-30,-30,-30),143),
      rep(p[7:9],143),
      rep(p[10:12],143),
      rep(c(-30,-30,-30),143),
      rep(c(p[13],-30,p[14]),143),
      rep(c(p[15],-30,p[16]),143),
      rep(p[17:19],143),
      rep(c(p[20:21],30),143),
      rep(c(p[22],-30,p[23]),143)),c(429,4,3))
tran <- matrix(c(0.67,0,0,0.33,
	0.25,0.75,0,0,
	0.12,0.62,0.26,0,
	0,0,1,0),ncol=4,byrow=T)
print(z <- hidden(yexon,dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
p <- c(z$coef[1:2],-30,z$coef[3:6],-30,-30,-30,-30,-30,z$coef[7:12],
	-30,-30,-30,z$coef[13],-30,z$coef[14:15],-30,z$coef[16:21],30,
	z$coef[22],-30,z$coef[23])
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))
if(interactive()){
postscript("dna5.eps")
plot(z,nind=c(1,3),main=c(expression(alpha[1]-globin),
	expression(theta[1]-globin)))
#postscript("dna5s.eps")
#plot(z,nind=c(1,3),smooth=T,main=c(expression(alpha[1]-globin),
#	expression(theta[1]-globin)))
dev.off()
}

tran <- matrix(c(0.41,0,0,0.59,
	0.25,0.75,0,0,
	0.12,0.62,0.26,0,
	0,0,1,0),ncol=4,byrow=T)
print(z <- hidden(y[1:2,exon],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
p <- c(z$coef[1:2],-30,z$coef[3:6],-30,-30,-30,-30,-30,z$coef[7:12],
	-30,-30,-30,z$coef[13],-30,z$coef[14:15],-30,z$coef[16:21],30,
	z$coef[22],-30,z$coef[23])
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))
if(interactive()){
#postscript("dna5s.eps")
par(mfcol=c(4,2),font.main=1)
plot(1:429,z$filt[1,covind(z)==1],type="l",xlab="",ylab="State 1",
	main=expression(alpha[1]-globin),ylim=c(0,1))
plot(1:429,z$filt[2,covind(z)==1],type="l",xlab="",ylab="State 2",ylim=c(0,1))
plot(1:429,z$filt[3,covind(z)==1],type="l",xlab="",ylab="State 3",ylim=c(0,1))
plot(1:429,z$filt[4,covind(z)==1],type="l",xlab="Time",ylab="State 4",
	ylim=c(0,1))
}

print(z <- hidden(y[3:4,exon],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
p <- c(z$coef[1:2],-30,z$coef[3:6],-30,-30,-30,-30,-30,z$coef[7:12],
	-30,-30,-30,z$coef[13],-30,z$coef[14:15],-30,z$coef[16:21],30,
	z$coef[22],-30,z$coef[23])
c(1,exp(p[seq(1,36,by=12)]))/(1+sum(exp(p[seq(1,36,by=12)])))
c(1,exp(p[seq(4,36,by=12)]))/(1+sum(exp(p[seq(4,36,by=12)])))
c(1,exp(p[seq(7,36,by=12)]))/(1+sum(exp(p[seq(7,36,by=12)])))
c(1,exp(p[seq(10,36,by=12)]))/(1+sum(exp(p[seq(10,36,by=12)])))

c(1,exp(p[seq(2,36,by=12)]))/(1+sum(exp(p[seq(2,36,by=12)])))
c(1,exp(p[seq(5,36,by=12)]))/(1+sum(exp(p[seq(5,36,by=12)])))
c(1,exp(p[seq(8,36,by=12)]))/(1+sum(exp(p[seq(8,36,by=12)])))
c(1,exp(p[seq(11,36,by=12)]))/(1+sum(exp(p[seq(11,36,by=12)])))

c(1,exp(p[seq(3,36,by=12)]))/(1+sum(exp(p[seq(3,36,by=12)])))
c(1,exp(p[seq(6,36,by=12)]))/(1+sum(exp(p[seq(6,36,by=12)])))
c(1,exp(p[seq(9,36,by=12)]))/(1+sum(exp(p[seq(9,36,by=12)])))
c(1,exp(p[seq(12,36,by=12)]))/(1+sum(exp(p[seq(12,36,by=12)])))
if(interactive()){
plot(1:429,z$filt[1,covind(z)==1],type="l",xlab="",ylab="",
	main=expression(theta[1]-globin),ylim=c(0,1))
plot(1:429,z$filt[2,covind(z)==1],type="l",xlab="",ylab="",ylim=c(0,1))
plot(1:429,z$filt[3,covind(z)==1],type="l",xlab="",ylab="",ylim=c(0,1))
plot(1:429,z$filt[4,covind(z)==1],type="l",xlab="Time",ylab="",ylim=c(0,1))
dev.off()
}

print(z <- hidden(y[1,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
print(z <- hidden(y[2,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
print(z <- hidden(y[3,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
print(z <- hidden(y[4,exon,drop=F],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,23),iter=200))
