library(repeated)

ss <- read.table("locust.dat",skip=1)

mu0 <- function(p) cbind(rep(p[1],161),rep(p[2],161))
mu1 <- function(p) matrix(p,ncol=2,byrow=T)
mu2 <- function(p) matrix(rep(p*(1:161),2),ncol=2)
mu3 <- function(p) cbind(p[1]*(1:161),p[2]*(1:161))
mu4 <- function(p) cbind(p[1]+p[3]*(1:161),p[2]+p[3]*(1:161))

s <- as.matrix(ss[,seq(1,ncol(ss),by=2)])

trend <- rep(1:161,12)
lag <- as.vector(rbind(rep(0,12),s[1:160,]))
id <- gl(12,161)
print(u0 <- glm(as.vector(s)~1,family=binomial))
u0$aic/2
print(u1 <- glm(as.vector(s)~trend,family=binomial))
u1$aic/2
print(u2 <- glm(as.vector(s)~lag,family=binomial))
u2$aic/2
print(u3 <- glm(as.vector(s)~lag+trend,family=binomial))
u3$aic/2
print(u4 <- glm(as.vector(s)~lag+trend+id,family=binomial))
u4$aic/2
print(u5 <- glm(as.vector(s)~trend+id,family=binomial))
u5$aic/2
print(u6 <- glm(as.vector(s)~lag+id,family=binomial))
u6$aic/2
print(u7 <- glm(as.vector(s)~id,family=binomial))
u7$aic/2

y <- restovec(t(s))
gamma <- matrix(c(0.9943,0.0057,0.0109,0.9891),ncol=2,byrow=T)
print(z0 <- hidden(y,pgamma=gamma,tvmu=mu0,ptvmu=c(-1,-1)))
print(z1 <- hidden(y,pgamma=matrix(c(0.99,0.01,0.02,0.98),
	 ncol=2,byrow=T),cmu=mu1,pcmu=rep(-1.5,24),iter=200))
print(z2 <- hidden(y,pgamma=gamma,tvmu=mu4,ptvmu=c(-5,-4,0.014)))
print(z3 <- hidden(y,cmu=mu1,tvmu=mu2,pcmu=rep(-1.5,24),iter=200,
	pgamma=matrix(c(0.975,0.025,0.055,0.945),ncol=2,byrow=T),ptvmu=0.014))
print(z4 <- hidden(y,pgamma=gamma,cmu=mu1,tvmu=mu3,pcmu=rep(-3.5,24),
	ptvmu=c(0.0145,0.0145)))

if(interactive()){
postscript("locust.eps")
par(mfcol=c(4,2),font.main=1)
plot(1:161,z3$filt[2,covind(z3)==1],type="l",xlab="",ylab=expression(pi[2]),
	main="Fed",ylim=c(0,1))
plot(1:161,z3$filt[2,covind(z3)==2],type="l",xlab="",ylab=expression(pi[2]),
	ylim=c(0,1))
plot(1:161,z3$filt[2,covind(z3)==5],type="l",xlab="",ylab=expression(pi[2]),
	ylim=c(0,1))
plot(1:161,z3$filt[2,covind(z3)==7],type="l",xlab="Time",
	ylab=expression(pi[2]),ylim=c(0,1))
}

s <- as.matrix(ss[,seq(2,ncol(ss),by=2)])

lag <- as.vector(rbind(rep(0,12),s[1:160,]))
print(u0 <- glm(as.vector(s)~1,family=binomial))
u0$aic/2
print(u1 <- glm(as.vector(s)~trend,family=binomial))
u1$aic/2
print(u2 <- glm(as.vector(s)~lag,family=binomial))
u2$aic/2
print(u3 <- glm(as.vector(s)~lag+trend,family=binomial))
u3$aic/2
print(u4 <- glm(as.vector(s)~lag+trend+id,family=binomial))
u4$aic/2
print(u5 <- glm(as.vector(s)~trend+id,family=binomial))
u5$aic/2
print(u6 <- glm(as.vector(s)~lag+id,family=binomial))
u6$aic/2
print(u7 <- glm(as.vector(s)~id,family=binomial))
u7$aic/2

y <- restovec(t(s))
gamma <- matrix(c(0.965,0.035,0.025,0.975),ncol=2,byrow=T)
param <- t(matrix(c(-1.93,-0.08,-1.70,-1.01,-1.21,1.77,-0.23,0.94,0.06,-0.64,
      -3.80,-2.20,-0.96,-0.35,-1.75,-1.37,-2.36,-1.21,-0.51,-0.17,-2.56,-1.27,
      -1.19,-1.59),ncol=2,byrow=T))
print(z0 <- hidden(y,pgamma=gamma,tvmu=mu0,ptvmu=c(-1,-1)))
print(z1 <- hidden(y,pgamma=matrix(c(0.97,0.03,0.03,0.97),ncol=2,byrow=T),
	 cmu=mu1,pcmu=param,iter=200))
print(z2 <- hidden(y,pgamma=gamma,tvmu=mu4,ptvmu=c(0,0,0.02)))
print(z3 <- hidden(y,cmu=mu1,tvmu=mu2,pcmu=param,iter=200,
	pgamma=matrix(c(0.975,0.025,0.025,0.975),ncol=2,byrow=T),ptvmu=0.01))
print(z4 <- hidden(y,pgamma=matrix(c(0.971,0.029,0.027,0.973),ncol=2,
	byrow=T),iter=200,cmu=mu1,tvmu=mu3,pcmu=param,ptvmu=c(0.011,0.011)))

if(interactive()){
plot(1:161,z3$filt[2,covind(z3)==1],type="l",xlab="",ylab="",main="Unfed",
	ylim=c(0,1))
plot(1:161,z3$filt[2,covind(z3)==2],type="l",xlab="",ylab="",ylim=c(0,1))
plot(1:161,z3$filt[2,covind(z3)==5],type="l",xlab="",ylab="",ylim=c(0,1))
plot(1:161,z3$filt[2,covind(z3)==7],type="l",xlab="Time",ylab="",ylim=c(0,1))
}
rm(u0,u1,u2,u3,u4,u5,u6,u7,z0,z1,z2,z3,z4)

s <- as.matrix(ss)

trend <- rep(1:161,24)
lag <- as.vector(rbind(rep(0,12),as.matrix(ss[1:160,])))
id <- gl(24,161)
treat <- gl(2,1932,3864)
print(u0 <- glm(as.vector(s)~1,family=binomial))
u0$aic/2
print(u1 <- glm(as.vector(s)~trend,family=binomial))
u1$aic/2
print(u2 <- glm(as.vector(s)~lag,family=binomial))
u2$aic/2
print(u3 <- glm(as.vector(s)~lag+trend,family=binomial))
u3$aic/2
print(u4 <- glm(as.vector(s)~lag+trend+id,family=binomial))
u4$aic/2
print(u5 <- glm(as.vector(s)~trend+id,family=binomial))
u5$aic/2
rm(u0,u1,u2,u3,u4,u5)
print(u6 <- glm(as.vector(s)~lag+id,family=binomial))
u6$aic/2
print(u7 <- glm(as.vector(s)~id,family=binomial))
u7$aic/2
print(u8 <- glm(as.vector(s)~treat,family=binomial))
u8$aic/2
print(u9 <- glm(as.vector(s)~treat+trend,family=binomial))
u9$aic/2
print(u10 <- glm(as.vector(s)~treat*trend,family=binomial))
u10$aic/2
rm(u6,u7,u8,u9,u10)
print(u11 <- glm(as.vector(s)~treat+lag,family=binomial))
u11$aic/2
print(u12 <- glm(as.vector(s)~treat+trend+lag,family=binomial))
u12$aic/2
print(u13 <- glm(as.vector(s)~treat*trend+lag,family=binomial))
u13$aic/2
print(u14 <- glm(as.vector(s)~lag+trend:treat+id,family=binomial))
u14$aic/2
rm(u11,u12,u13,u14)

mu0 <- function(p) cbind(rep(p[1],161),rep(p[2],161))
mu1 <- function(p) matrix(p,ncol=2,byrow=T)
mu2 <- function(p) matrix(rep(p*(1:161),2),ncol=2)
mu3 <- function(p) cbind(p[1]*(1:161),p[2]*(1:161))
mu4 <- function(p) cbind(p[1]+p[3]*(1:161),p[2]+p[3]*(1:161))
mu5 <- function(p) cbind(p[1]+p[3]*(1:161),p[2]+p[4]*(1:161))
mu6 <- function(p) cbind(c(rep(p[1],12),rep(p[2],12)),
	c(rep(p[3],12),rep(p[4],12)))

y <- restovec(t(s))
print(z0 <- hidden(y,pgamma=matrix(c(0.96,0.04,0.03,0.97),
	 ncol=2,byrow=T),tvmu=mu0,ptvmu=c(-1,-1)))
print(z1 <- hidden(y,pgamma=matrix(c(0.98,0.02,0.02,0.98),
	 ncol=2,byrow=T),cmu=mu1,pcmu=rep(-2,48),iter=200))
print(z2 <- hidden(y,pgamma=matrix(c(0.96,0.04,0.03,0.97),
	 ncol=2,byrow=T),tvmu=mu4,ptvmu=c(-1,-1,0.014)))
print(z3 <- hidden(y,pgamma=matrix(c(0.98,0.02,0.02,0.98),
	ncol=2,byrow=T),cmu=mu1,tvmu=mu2,pcmu=rep(-2,48),ptvmu=0.01,iter=200))
print(z4 <- hidden(y,pgamma=matrix(c(0.976,0.024,0.023,0.977),
	ncol=2,byrow=T),cmu=mu1,tvmu=mu3,pcmu=z3$coef[1:48],iter=200,
	ptvmu=c(0.0076,0.0076)))
rm(z1,z2,z3,z4)
print(z5 <- hidden(y,pgamma=matrix(c(0.98,0.02,0.01,0.99),
	 ncol=2,byrow=T),tvmu=mu5,ptvmu=c(-0.018,-3.7,0.0073,0.0073)))
print(z6 <- hidden(y,pgamma=matrix(c(0.96,0.04,0.03,0.97),
	 ncol=2,byrow=T),cmu=mu6,pcmu=rep(-1,4),iter=200))
print(z7 <- hidden(y,pgamma=matrix(c(0.99,0.01,0.02,0.98),
	 ncol=2,byrow=T),cmu=mu6,tvmu=mu2,pcmu=c(-3.5,-3,0.8,0.55),
	 ptvmu=0.01,iter=200))
print(z8 <- hidden(y,pgamma=matrix(c(0.99,0.01,0.02,0.98),
	 ncol=2,byrow=T),cmu=mu6,tvmu=mu3,pcmu=c(-4,-4,0,-0.65),iter=200,
	 ptvmu=c(0.01,0.01)))
