# requires -v7 for glm

library(repeated)

data <- unlist(strsplit(scan("dna4.dat",what=character(0),skip=1),split=NULL))
y <- rbind(codes(as.factor(data[1:1631])),codes(as.factor(data[1632:3262])))
for(i in 1:2)y[i,] <- ifelse(y[i,]==1,NA,y[i,]-1)

mu2a <- function(p) array(p,c(1,2,3))
mu3a <- function(p) array(p,c(1,3,3))
mu4a <- function(p) array(p,c(1,4,3))
mu5a <- function(p) array(p,c(1,5,3))
mu6a <- function(p) array(p,c(1,6,3))

junk <- c(1:314,433:558,674:1020,1139:1297,1439:1631)
intron <- c(433:558,674:1020,1139:1297)
gene <- c(315:432,559:673,1021:1138,1298:1438)

y1i <- y[1,junk,drop=F]
y1i <- y1i[1,y1i[1,]!=1,drop=F]
y1ii <- y[1,intron,drop=F]
y1ii <- y1ii[1,y1ii[1,]!=1,drop=F]
y1g <- y[1,gene,drop=F]
y1g <- y1g[1,y1g[1,]!=1,drop=F]

yy <- as.numeric(c(t(y[,gene])==1,t(y[,gene])==2,t(y[,gene])==3,
	t(y[,gene])==4))
tapply(yy,list(gl(4,984)),sum)
tapply(yy,list(gl(4,984),gl(2,492,3936)),sum)
tapply(yy,list(as.factor(c(1,rep(t(y[,gene]),4)[1:3935])),gl(4,984)),sum)
print(tot <- apply(tapply(yy,list(as.factor(c(1,rep(t(y[,gene]),4)[1:3935])),
	gl(4,984)),sum),1,sum))
tot/(sum(tot))
tapply(yy,list(as.factor(c(1,rep(t(y[,gene]),4)[1:3935])),gl(4,984)),sum)/rep(tot,4)
tab <- tapply(yy,list(gl(4,984),gl(2,492,3936),as.factor(c(1,rep(t(y[,gene]),4)[1:3935]))),sum)
tab

state <- gl(4,984)
state1 <- as.factor(c(1,rep(t(y[,gene]),4)[1:3935]))
wt <- rep(1,3936)
wt[seq(1,3936,by=492)] <- 0
print(z <- glm(yy~state,family=poisson,weight=wt))
-sum(yy*log(z$fit))
-sum(wt*yy*log(z$fit))-2*log(sum(wt[2917:3936]*z$fit[2917:3936])/984)
print(z <- glm(yy~state*state1,family=poisson,weight=wt))
-sum(yy*log(z$fit))
-sum(wt*yy*log(z$fit))-2*log(sum(wt[2917:3936]*z$fit[2917:3936])/984)

yy1 <- t(y[,intron])
yy1[yy1==0] <- NA
yy <- as.numeric(c(yy1==1,yy1==2,yy1==3,yy1==4))
tapply(yy,list(gl(4,1264)),sum,na.rm=T)
tapply(yy,list(gl(4,1264),gl(2,632,5056)),sum,na.rm=T)
tapply(yy,list(as.factor(c(1,rep(yy1,4)[1:5055])),gl(4,1264)),sum,na.rm=T)
print(tot <- apply(tapply(yy,list(as.factor(c(1,rep(yy1,4)[1:5055])),
	gl(4,1264)),sum,na.rm=T),1,sum,na.rm=T))
tot/(sum(tot))
tapply(yy,list(as.factor(c(1,rep(yy1,4)[1:5055])),gl(4,1264)),sum,na.rm=T)/rep(tot,4)
tab <- tapply(yy,list(gl(4,1264),gl(2,632,5056),as.factor(c(1,rep(yy1,4)[1:5055]))),sum,na.rm=T)
tab

state <- gl(4,1264)
state1 <- as.factor(c(1,rep(yy1,4)[1:5055]))
wt <- rep(1,5056)
wt[seq(1,5056,by=632)] <- 0
print(z <- glm(yy~state,family=poisson,weight=wt))
-sum(yy[!is.na(yy)]*log(z$fit))
print(z <- glm(yy~state*state1,family=poisson,weight=wt))
-sum(yy[!is.na(yy)&!is.na(state1)]*log(z$fit))

print(z <- hidden(y1ii,dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=mu2a,pcmu=rep(1,6),iter=200))
c(exp(z$coef[seq(1,6,by=2)]),1)/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(exp(z$coef[seq(2,6,by=2)]),1)/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(y1g,dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=mu2a,pcmu=rep(1,6),iter=200))
c(exp(z$coef[seq(1,6,by=2)]),1)/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(exp(z$coef[seq(2,6,by=2)]),1)/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(y1ii,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3a,pcmu=rep(1,9),iter=200))
c(exp(z$coef[seq(1,9,by=3)]),1)/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(exp(z$coef[seq(2,9,by=3)]),1)/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(exp(z$coef[seq(3,9,by=3)]),1)/(1+sum(exp(z$coef[seq(3,9,by=3)])))

print(z <- hidden(y1g,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3a,pcmu=rep(1,9),iter=200))
c(exp(z$coef[seq(1,9,by=3)]),1)/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(exp(z$coef[seq(2,9,by=3)]),1)/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(exp(z$coef[seq(3,9,by=3)]),1)/(1+sum(exp(z$coef[seq(3,9,by=3)])))

tran <- matrix(c(0.4,0.2,0.2,0.2,0.2,0.4,0.2,0.2,0.2,0.2,0.4,0.2,0.2,0.2,0.1,0.5),ncol=4,byrow=T)
print(z <- hidden(y1ii,dist="mult",pgamma=tran,
	cmu=mu4a,pcmu=rep(1,12),iter=200))
c(exp(z$coef[seq(1,12,by=4)]),1)/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(exp(z$coef[seq(2,12,by=4)]),1)/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(exp(z$coef[seq(3,12,by=4)]),1)/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(exp(z$coef[seq(4,12,by=4)]),1)/(1+sum(exp(z$coef[seq(4,12,by=4)])))

print(z <- hidden(y1g,dist="mult",pgamma=tran,
	cmu=mu4a,pcmu=rep(1,12),iter=200))
c(exp(z$coef[seq(1,12,by=4)]),1)/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(exp(z$coef[seq(2,12,by=4)]),1)/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(exp(z$coef[seq(3,12,by=4)]),1)/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(exp(z$coef[seq(4,12,by=4)]),1)/(1+sum(exp(z$coef[seq(4,12,by=4)])))

tran <- matrix(0.1,ncol=5,nrow=5)
diag(tran) <- 0.6
tran[1,1] <- 0.5
tran[1,2] <- 0.2
print(z <- hidden(y1g,dist="mult",pgamma=tran,
	cmu=mu5a,pcmu=rep(-1,15),iter=200))
c(exp(z$coef[seq(1,15,by=5)]),1)/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(exp(z$coef[seq(2,15,by=5)]),1)/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(exp(z$coef[seq(3,15,by=5)]),1)/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(exp(z$coef[seq(4,15,by=5)]),1)/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(exp(z$coef[seq(5,15,by=5)]),1)/(1+sum(exp(z$coef[seq(5,15,by=5)])))

print(z <- hidden(y1ii,dist="mult",pgamma=tran,
	cmu=mu5a,pcmu=rep(-1,15),iter=200))
c(exp(z$coef[seq(1,15,by=5)]),1)/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(exp(z$coef[seq(2,15,by=5)]),1)/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(exp(z$coef[seq(3,15,by=5)]),1)/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(exp(z$coef[seq(4,15,by=5)]),1)/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(exp(z$coef[seq(5,15,by=5)]),1)/(1+sum(exp(z$coef[seq(5,15,by=5)])))

tran <- matrix(0.15,ncol=6,nrow=6)
diag(tran) <- 0.25
tran[1,1] <- 0.2
tran[1,2] <- 0.2
print(z <- hidden(y1g,dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(1,18),iter=200))
c(exp(z$coef[seq(1,18,by=6)]),1)/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(exp(z$coef[seq(2,18,by=6)]),1)/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(exp(z$coef[seq(3,18,by=6)]),1)/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(exp(z$coef[seq(4,18,by=6)]),1)/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(exp(z$coef[seq(5,18,by=6)]),1)/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(exp(z$coef[seq(6,18,by=6)]),1)/(1+sum(exp(z$coef[seq(6,18,by=6)])))

print(z <- hidden(y1ii,dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(-1,18),iter=200))
c(exp(z$coef[seq(1,18,by=6)]),1)/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(exp(z$coef[seq(2,18,by=6)]),1)/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(exp(z$coef[seq(3,18,by=6)]),1)/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(exp(z$coef[seq(4,18,by=6)]),1)/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(exp(z$coef[seq(5,18,by=6)]),1)/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(exp(z$coef[seq(6,18,by=6)]),1)/(1+sum(exp(z$coef[seq(6,18,by=6)])))

y2i <- y[2,junk,drop=F]
y2i <- y2i[1,y2i[1,]!=1,drop=F]
y2ii <- y[2,intron,drop=F]
y2ii <- y2ii[1,y2ii[1,]!=1,drop=F]
y2g <- y[2,gene,drop=F]
y2g <- y2g[1,y2g[1,]!=1,drop=F]

print(z <- hidden(y2ii,dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=mu2a,pcmu=rep(1,6),iter=200))
c(exp(z$coef[seq(1,6,by=2)]),1)/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(exp(z$coef[seq(2,6,by=2)]),1)/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(y2g,dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=mu2a,pcmu=rep(1,6),iter=200))
c(exp(z$coef[seq(1,6,by=2)]),1)/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(exp(z$coef[seq(2,6,by=2)]),1)/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(y2ii,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3a,pcmu=rep(1,9),iter=200))
c(exp(z$coef[seq(1,9,by=3)]),1)/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(exp(z$coef[seq(2,9,by=3)]),1)/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(exp(z$coef[seq(3,9,by=3)]),1)/(1+sum(exp(z$coef[seq(3,9,by=3)])))

print(z <- hidden(y2g,dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3a,pcmu=rep(1,9),iter=200))
c(exp(z$coef[seq(1,9,by=3)]),1)/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(exp(z$coef[seq(2,9,by=3)]),1)/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(exp(z$coef[seq(3,9,by=3)]),1)/(1+sum(exp(z$coef[seq(3,9,by=3)])))

tran <- matrix(c(0.2502,0.4720,0.2505,0.0273,0.1225,0.1928,0.0329,0.6518,
	0.2011,0.1526,0.2227,0.4236,0.1954,0.2253,0.1423,0.4370),
	ncol=4,byrow=T)
print(z <- hidden(y2ii,dist="mult",pgamma=tran,
	cmu=mu4a,pcmu=rep(1,12),iter=200))
c(exp(z$coef[seq(1,12,by=4)]),1)/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(exp(z$coef[seq(2,12,by=4)]),1)/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(exp(z$coef[seq(3,12,by=4)]),1)/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(exp(z$coef[seq(4,12,by=4)]),1)/(1+sum(exp(z$coef[seq(4,12,by=4)])))

tran <- matrix(c(0.3,0.2,0.3,0.2,0.3,0.3,0.2,0.2,0.2,0.2,0.4,0.2,0.2,0.2,0.1,0.5),ncol=4,byrow=T)
print(z <- hidden(y2g,dist="mult",pgamma=tran,
	cmu=mu4a,pcmu=rep(-1,12),iter=200))
c(exp(z$coef[seq(1,12,by=4)]),1)/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(exp(z$coef[seq(2,12,by=4)]),1)/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(exp(z$coef[seq(3,12,by=4)]),1)/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(exp(z$coef[seq(4,12,by=4)]),1)/(1+sum(exp(z$coef[seq(4,12,by=4)])))

tran <- matrix(0.1,ncol=5,nrow=5)
diag(tran) <- 0.6
tran[1,1] <- 0.5
tran[1,2] <- 0.2
print(z <- hidden(y2ii,dist="mult",pgamma=tran,
	cmu=mu5a,pcmu=rep(-1,15),iter=200))
c(exp(z$coef[seq(1,15,by=5)]),1)/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(exp(z$coef[seq(2,15,by=5)]),1)/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(exp(z$coef[seq(3,15,by=5)]),1)/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(exp(z$coef[seq(4,15,by=5)]),1)/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(exp(z$coef[seq(5,15,by=5)]),1)/(1+sum(exp(z$coef[seq(5,15,by=5)])))

print(z <- hidden(y2g,dist="mult",pgamma=tran,
	cmu=mu5a,pcmu=rep(-1,15),iter=200))
c(exp(z$coef[seq(1,15,by=5)]),1)/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(exp(z$coef[seq(2,15,by=5)]),1)/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(exp(z$coef[seq(3,15,by=5)]),1)/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(exp(z$coef[seq(4,15,by=5)]),1)/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(exp(z$coef[seq(5,15,by=5)]),1)/(1+sum(exp(z$coef[seq(5,15,by=5)])))

tran <- matrix(0.15,ncol=6,nrow=6)
diag(tran) <- 0.25
tran[1,1] <- 0.2
tran[1,2] <- 0.2
print(z <- hidden(y2ii,dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(-1,18),iter=200))
c(exp(z$coef[seq(1,18,by=6)]),1)/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(exp(z$coef[seq(2,18,by=6)]),1)/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(exp(z$coef[seq(3,18,by=6)]),1)/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(exp(z$coef[seq(4,18,by=6)]),1)/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(exp(z$coef[seq(5,18,by=6)]),1)/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(exp(z$coef[seq(6,18,by=6)]),1)/(1+sum(exp(z$coef[seq(6,18,by=6)])))

print(z <- hidden(y2g,dist="mult",pgamma=tran,
	cmu=mu6a,pcmu=rep(1,18),iter=200))
c(exp(z$coef[seq(1,18,by=6)]),1)/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(exp(z$coef[seq(2,18,by=6)]),1)/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(exp(z$coef[seq(3,18,by=6)]),1)/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(exp(z$coef[seq(4,18,by=6)]),1)/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(exp(z$coef[seq(5,18,by=6)]),1)/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(exp(z$coef[seq(6,18,by=6)]),1)/(1+sum(exp(z$coef[seq(6,18,by=6)])))

mu2b <- function(p) array(rep(p,rep(2,6)),c(2,2,3))
mu3b <- function(p) array(rep(p,rep(2,9)),c(2,3,3))
mu4b <- function(p) array(rep(p,rep(2,12)),c(2,4,3))
mu5b <- function(p) array(rep(p,rep(2,15)),c(2,5,3))
mu6b <- function(p) array(rep(p,rep(2,18)),c(2,6,3))

print(z <- hidden(y[,intron],dist="mult",
	pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=mu2b,pcmu=rep(1,6),iter=200))
c(exp(z$coef[seq(1,6,by=2)]),1)/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(exp(z$coef[seq(2,6,by=2)]),1)/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(y[,gene],dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),cmu=mu2b,pcmu=rep(1,6),iter=200))
c(exp(z$coef[seq(1,6,by=2)]),1)/(1+sum(exp(z$coef[seq(1,6,by=2)])))
c(exp(z$coef[seq(2,6,by=2)]),1)/(1+sum(exp(z$coef[seq(2,6,by=2)])))

print(z <- hidden(y[,intron],dist="mult",
	pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3b,pcmu=rep(1,9),iter=200))
c(exp(z$coef[seq(1,9,by=3)]),1)/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(exp(z$coef[seq(2,9,by=3)]),1)/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(exp(z$coef[seq(3,9,by=3)]),1)/(1+sum(exp(z$coef[seq(3,9,by=3)])))

print(z <- hidden(y[,gene],dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),cmu=mu3b,pcmu=rep(1,9),iter=200))
c(exp(z$coef[seq(1,9,by=3)]),1)/(1+sum(exp(z$coef[seq(1,9,by=3)])))
c(exp(z$coef[seq(2,9,by=3)]),1)/(1+sum(exp(z$coef[seq(2,9,by=3)])))
c(exp(z$coef[seq(3,9,by=3)]),1)/(1+sum(exp(z$coef[seq(3,9,by=3)])))

tran <- matrix(c(0.2502,0.4720,0.2505,0.0273,0.1225,0.1928,0.0329,0.6518,
	0.2011,0.1526,0.2227,0.4236,0.1954,0.2253,0.1423,0.4370),
	ncol=4,byrow=T)
print(z <- hidden(y[,intron],dist="mult",pgamma=tran,
	cmu=mu4b,pcmu=rep(1,12),iter=200))
c(exp(z$coef[seq(1,12,by=4)]),1)/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(exp(z$coef[seq(2,12,by=4)]),1)/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(exp(z$coef[seq(3,12,by=4)]),1)/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(exp(z$coef[seq(4,12,by=4)]),1)/(1+sum(exp(z$coef[seq(4,12,by=4)])))

tran <- matrix(0.2,ncol=4,nrow=4)
diag(tran) <- 0.3
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- 0.3
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	cmu=mu4b,pcmu=rep(-1,12),iter=200))
c(exp(z$coef[seq(1,12,by=4)]),1)/(1+sum(exp(z$coef[seq(1,12,by=4)])))
c(exp(z$coef[seq(2,12,by=4)]),1)/(1+sum(exp(z$coef[seq(2,12,by=4)])))
c(exp(z$coef[seq(3,12,by=4)]),1)/(1+sum(exp(z$coef[seq(3,12,by=4)])))
c(exp(z$coef[seq(4,12,by=4)]),1)/(1+sum(exp(z$coef[seq(4,12,by=4)])))

tran <- matrix(0.1,ncol=5,nrow=5)
diag(tran) <- 0.6
tran[1,1] <- tran[5,5] <- 0.5
tran[1,2] <- tran[5,2] <- 0.2
print(z <- hidden(y[,intron],dist="mult",pgamma=tran,
	cmu=mu5b,pcmu=rep(-1,15),iter=200))
c(exp(z$coef[seq(1,15,by=5)]),1)/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(exp(z$coef[seq(2,15,by=5)]),1)/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(exp(z$coef[seq(3,15,by=5)]),1)/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(exp(z$coef[seq(4,15,by=5)]),1)/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(exp(z$coef[seq(5,15,by=5)]),1)/(1+sum(exp(z$coef[seq(5,15,by=5)])))

tran <- matrix(0.1,ncol=5,nrow=5)
diag(tran) <- 0.5
tran[1,2] <- tran[2,3] <- tran[3,2] <- tran[4,2] <- tran[5,2] <- 0.2
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	cmu=mu5b,pcmu=rep(-1,15),iter=200))
c(exp(z$coef[seq(1,15,by=5)]),1)/(1+sum(exp(z$coef[seq(1,15,by=5)])))
c(exp(z$coef[seq(2,15,by=5)]),1)/(1+sum(exp(z$coef[seq(2,15,by=5)])))
c(exp(z$coef[seq(3,15,by=5)]),1)/(1+sum(exp(z$coef[seq(3,15,by=5)])))
c(exp(z$coef[seq(4,15,by=5)]),1)/(1+sum(exp(z$coef[seq(4,15,by=5)])))
c(exp(z$coef[seq(5,15,by=5)]),1)/(1+sum(exp(z$coef[seq(5,15,by=5)])))
tran <- matrix(c(0,0.48,0.52,0,0,
	0.18,0.56,0.18,0,0.08,
	0,0,0,0,1,
	0.73,0.07,0,0.20,0,
	0.38,0,0.41,0.21,0),ncol=5,byrow=T)
mu5c <- function(p) array(rep(c(-30,p[1:2],-30,p[3:4],-30,p[5],-30,p[6:9],-30,
	-30),rep(2,15)),c(2,5,3))
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	cmu=mu5c,pcmu=rep(0,9),iter=200))
p <- c(-30,z$coef[1:2],-30,z$coef[3:4],-30,z$coef[5],-30,
	z$coef[6:9],-30,-30)
c(exp(p[seq(1,15,by=5)]),1)/(1+sum(exp(p[seq(1,15,by=5)])))
c(exp(p[seq(2,15,by=5)]),1)/(1+sum(exp(p[seq(2,15,by=5)])))
c(exp(p[seq(3,15,by=5)]),1)/(1+sum(exp(p[seq(3,15,by=5)])))
c(exp(p[seq(4,15,by=5)]),1)/(1+sum(exp(p[seq(4,15,by=5)])))
c(exp(p[seq(5,15,by=5)]),1)/(1+sum(exp(p[seq(5,15,by=5)])))

tran <- matrix(0.15,ncol=6,nrow=6)
diag(tran) <- 0.25
tran[1,1] <- 0.2
tran[1,2] <- 0.2
print(z <- hidden(y[,intron],dist="mult",pgamma=tran,
	cmu=mu6b,pcmu=rep(-1,18),iter=200))
c(exp(z$coef[seq(1,18,by=6)]),1)/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(exp(z$coef[seq(2,18,by=6)]),1)/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(exp(z$coef[seq(3,18,by=6)]),1)/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(exp(z$coef[seq(4,18,by=6)]),1)/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(exp(z$coef[seq(5,18,by=6)]),1)/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(exp(z$coef[seq(6,18,by=6)]),1)/(1+sum(exp(z$coef[seq(6,18,by=6)])))

tran <- matrix(0.1,ncol=6,nrow=6)
diag(tran) <- 0.2
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- tran[5,1] <- 
	  tran[6,2] <- 0.4
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	cmu=mu6b,pcmu=rep(1,18),iter=200))
c(exp(z$coef[seq(1,18,by=6)]),1)/(1+sum(exp(z$coef[seq(1,18,by=6)])))
c(exp(z$coef[seq(2,18,by=6)]),1)/(1+sum(exp(z$coef[seq(2,18,by=6)])))
c(exp(z$coef[seq(3,18,by=6)]),1)/(1+sum(exp(z$coef[seq(3,18,by=6)])))
c(exp(z$coef[seq(4,18,by=6)]),1)/(1+sum(exp(z$coef[seq(4,18,by=6)])))
c(exp(z$coef[seq(5,18,by=6)]),1)/(1+sum(exp(z$coef[seq(5,18,by=6)])))
c(exp(z$coef[seq(6,18,by=6)]),1)/(1+sum(exp(z$coef[seq(6,18,by=6)])))

tran <- matrix(c(0.17,0.14,0,0.4,0.18,0.11,
	0,0.35,0,0,0.35,0.3,
	0,0.58,0,0.38,0,0.04,
	0,0.1,0,0,0.52,0.38,
	0.41,0.1,0.43,0,0.06,0,
	0.2,0.52,0,0.1,0,0.18),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,30,-30,p[1],-30,p[2:3],-30,
	-30,p[4],-30,p[5:6],-30,30,-30),rep(2,18)),c(2,6,3))
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,6),iter=200))
p <- c(30,-30,-30,30,-30,z$coef[1],-30,z$coef[2:3],-30,
	-30,z$coef[4],-30,z$coef[5:6],-30,30,-30)
c(exp(p[seq(1,18,by=6)]),1)/(1+sum(exp(p[seq(1,18,by=6)])))
c(exp(p[seq(2,18,by=6)]),1)/(1+sum(exp(p[seq(2,18,by=6)])))
c(exp(p[seq(3,18,by=6)]),1)/(1+sum(exp(p[seq(3,18,by=6)])))
c(exp(p[seq(4,18,by=6)]),1)/(1+sum(exp(p[seq(4,18,by=6)])))
c(exp(p[seq(5,18,by=6)]),1)/(1+sum(exp(p[seq(5,18,by=6)])))
c(exp(p[seq(6,18,by=6)]),1)/(1+sum(exp(p[seq(6,18,by=6)])))

# model from alpha- and theta-globin (dna5.r)
tran <- matrix(c(0,0,0,0,1,0,
	0,0.06,0.6,0,0,0.34,
	0,0,0,0.31,0.69,0,
	0,0.75,0,0,0,0.25,
	0.09,0.69,0,0,0,0.22,
	0.2,0,0.1,0.59,0,0.11),ncol=6,byrow=T)
mu6c <- function(p) array(rep(c(30,-30,-30,-30,p[1:2],-30,p[3:4],30,-30,
	p[5],-30,p[6:7],-30,p[8:9]),rep(2,18)),c(2,6,3))
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	cmu=mu6c,pcmu=rep(0,9),iter=200))
p <- c(30,-30,-30,-30,z$coef[1:2],-30,z$coef[3:4],30,-30,
	z$coef[5],-30,z$coef[6:7],-30,z$coef[8:9])
c(exp(p[seq(1,18,by=6)]),1)/(1+sum(exp(p[seq(1,18,by=6)])))
c(exp(p[seq(2,18,by=6)]),1)/(1+sum(exp(p[seq(2,18,by=6)])))
c(exp(p[seq(3,18,by=6)]),1)/(1+sum(exp(p[seq(3,18,by=6)])))
c(exp(p[seq(4,18,by=6)]),1)/(1+sum(exp(p[seq(4,18,by=6)])))
c(exp(p[seq(5,18,by=6)]),1)/(1+sum(exp(p[seq(5,18,by=6)])))
c(exp(p[seq(6,18,by=6)]),1)/(1+sum(exp(p[seq(6,18,by=6)])))

# by triplets
mu2tv <- function(p) array(c(rep(p[1:3],164),
      rep(p[4:6],164),
      rep(p[7:9],164),
      rep(p[10:12],164),
      rep(p[13:15],164),
      rep(p[16:18],164)),c(492,2,3))
print(z <- hidden(y[,gene],dist="mult",pgamma=matrix(c(0.6,0.4,0.2,0.8),ncol=2,
	byrow=T),tvmu=mu2tv,ptvmu=rep(0,18),iter=200))
p <- z$coef
c(exp(p[seq(1,18,by=6)]),1)/(1+sum(exp(p[seq(1,18,by=6)])))
c(exp(p[seq(4,18,by=6)]),1)/(1+sum(exp(p[seq(4,18,by=6)])))

c(exp(p[seq(2,18,by=6)]),1)/(1+sum(exp(p[seq(2,18,by=6)])))
c(exp(p[seq(5,18,by=6)]),1)/(1+sum(exp(p[seq(5,18,by=6)])))

c(exp(p[seq(3,18,by=6)]),1)/(1+sum(exp(p[seq(3,18,by=6)])))
c(exp(p[seq(6,18,by=6)]),1)/(1+sum(exp(p[seq(6,18,by=6)])))

mu2tvc <- function(p) array(c(rep(c(p[1],-30,-30),164),
      rep(p[2:4],164),
      rep(p[5:7],164),
      rep(p[8:10],164),
      rep(c(-30,p[11:12]),164),
      rep(p[13:15],164)),c(492,2,3))
print(z <- hidden(y[,gene],dist="mult",pgamma=matrix(c(0.65,0.35,0.29,0.71),
	ncol=2,byrow=T),tvmu=mu2tvc,ptvmu=rep(0,15),iter=200))
p <- c(z$coef[1],-30,-30,z$coef[2:10],-30,z$coef[11:15])
c(exp(p[seq(1,18,by=6)]),1)/(1+sum(exp(p[seq(1,18,by=6)])))
c(exp(p[seq(4,18,by=6)]),1)/(1+sum(exp(p[seq(4,18,by=6)])))

c(exp(p[seq(2,18,by=6)]),1)/(1+sum(exp(p[seq(2,18,by=6)])))
c(exp(p[seq(5,18,by=6)]),1)/(1+sum(exp(p[seq(5,18,by=6)])))

c(exp(p[seq(3,18,by=6)]),1)/(1+sum(exp(p[seq(3,18,by=6)])))
c(exp(p[seq(6,18,by=6)]),1)/(1+sum(exp(p[seq(6,18,by=6)])))

mu3tv <- function(p) array(c(rep(p[1:3],164),
	rep(p[4:6],164),
	rep(p[7:9],164),
	rep(p[10:12],164),
	rep(p[13:15],164),
	rep(p[16:18],164),
	rep(p[19:21],164),
	rep(p[22:24],164),
	rep(p[25:27],164)),c(492,3,3))
print(z <- hidden(y[,gene],dist="mult",pgamma=matrix(c(0.1,0.4,0.5,0.3,0.4,
	0.3,0.3,0.2,0.5),ncol=3,byrow=T),tvmu=mu3tv,ptvmu=rep(0,27),iter=200))
p <- z$coef
c(exp(p[seq(1,27,by=9)]),1)/(1+sum(exp(p[seq(1,27,by=9)])))
c(exp(p[seq(4,27,by=9)]),1)/(1+sum(exp(p[seq(4,27,by=9)])))
c(exp(p[seq(7,27,by=9)]),1)/(1+sum(exp(p[seq(7,27,by=9)])))

c(exp(p[seq(2,27,by=9)]),1)/(1+sum(exp(p[seq(2,27,by=9)])))
c(exp(p[seq(5,27,by=9)]),1)/(1+sum(exp(p[seq(5,27,by=9)])))
c(exp(p[seq(8,27,by=9)]),1)/(1+sum(exp(p[seq(8,27,by=9)])))

c(exp(p[seq(3,27,by=9)]),1)/(1+sum(exp(p[seq(3,27,by=9)])))
c(exp(p[seq(6,27,by=9)]),1)/(1+sum(exp(p[seq(6,27,by=9)])))
c(exp(p[seq(9,27,by=9)]),1)/(1+sum(exp(p[seq(9,27,by=9)])))
mu3tvc <- function(p) array(c(rep(c(-30,p[1:2]),164),
      rep(c(p[3],-30,-30),164),
      rep(c(30,p[4],30),164),
      rep(p[5:7],164),
      rep(c(-30,p[8:9]),164),
      rep(c(-30,-30,-30),164),
      rep(p[10:12],164),
      rep(c(-30,-30,-30),164),
      rep(c(-30,p[13],-30),164)),c(492,3,3))
print(z <- hidden(y[,gene],dist="mult",pgamma=matrix(c(0.35,0.35,0.30,0.59,
	0.41,0,0.54,0.12,0.34),ncol=3,byrow=T),tvmu=mu3tvc,
	ptvmu=rep(0,13),iter=200))
p <- c(-30,z$coef[1:3],-30,-30,30,z$coef[4],30,z$coef[5:7],-30,z$coef[8:9],-30,
	-30,-30,z$coef[10:12],-30,-30,-30,-30,z$coef[13],-30)
c(exp(p[seq(1,27,by=9)]),1)/(1+sum(exp(p[seq(1,27,by=9)])))
c(exp(p[seq(4,27,by=9)]),1)/(1+sum(exp(p[seq(4,27,by=9)])))
c(exp(p[seq(7,27,by=9)]),1)/(1+sum(exp(p[seq(7,27,by=9)])))

c(exp(p[seq(2,27,by=9)]),1)/(1+sum(exp(p[seq(2,27,by=9)])))
c(exp(p[seq(5,27,by=9)]),1)/(1+sum(exp(p[seq(5,27,by=9)])))
c(exp(p[seq(8,27,by=9)]),1)/(1+sum(exp(p[seq(8,27,by=9)])))

c(exp(p[seq(3,27,by=9)]),1)/(1+sum(exp(p[seq(3,27,by=9)])))
c(exp(p[seq(6,27,by=9)]),1)/(1+sum(exp(p[seq(6,27,by=9)])))
c(exp(p[seq(9,27,by=9)]),1)/(1+sum(exp(p[seq(9,27,by=9)])))

mu4tv <- function(p) array(c(rep(p[1:3],164),
      rep(p[4:6],164),
      rep(p[7:9],164),
      rep(p[10:12],164),
      rep(p[13:15],164),
      rep(p[16:18],164),
      rep(p[19:21],164),
      rep(p[22:24],164),
      rep(p[25:27],164),
      rep(p[28:30],164),
      rep(p[31:33],164),
      rep(p[34:36],164)),c(492,4,3))
tran <- matrix(0.2,ncol=4,nrow=4)
diag(tran) <- 0.3
tran[1,4] <- tran[2,3] <- tran[3,2] <- tran[4,3] <- 0.3
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	tvmu=mu4tv,ptvmu=rep(0,36),iter=200))
p <- c(z$coef)
c(exp(p[seq(1,36,by=12)]),1)/(1+sum(exp(p[seq(1,36,by=12)])))
c(exp(p[seq(4,36,by=12)]),1)/(1+sum(exp(p[seq(4,36,by=12)])))
c(exp(p[seq(7,36,by=12)]),1)/(1+sum(exp(p[seq(7,36,by=12)])))
c(exp(p[seq(10,36,by=12)]),1)/(1+sum(exp(p[seq(10,36,by=12)])))

c(exp(p[seq(2,36,by=12)]),1)/(1+sum(exp(p[seq(2,36,by=12)])))
c(exp(p[seq(5,36,by=12)]),1)/(1+sum(exp(p[seq(5,36,by=12)])))
c(exp(p[seq(8,36,by=12)]),1)/(1+sum(exp(p[seq(8,36,by=12)])))
c(exp(p[seq(11,36,by=12)]),1)/(1+sum(exp(p[seq(11,36,by=12)])))

c(exp(p[seq(3,36,by=12)]),1)/(1+sum(exp(p[seq(3,36,by=12)])))
c(exp(p[seq(6,36,by=12)]),1)/(1+sum(exp(p[seq(6,36,by=12)])))
c(exp(p[seq(9,36,by=12)]),1)/(1+sum(exp(p[seq(9,36,by=12)])))
c(exp(p[seq(12,36,by=12)]),1)/(1+sum(exp(p[seq(12,36,by=12)])))
mu4tvc <- function(p) array(c(rep(c(p[1],-30,-30),164),
      rep(c(30,30,30),164),
      rep(c(-30,-30,p[2]),164),
      rep(c(p[3:5]),164),
      rep(c(p[6],30,p[7]),164),
      rep(c(-30,-30,-30),164),
      rep(c(-30,-30,-30),164),
      rep(c(p[8],-30,p[9]),164),
      rep(c(-30,-30,p[10]),164),
      rep(c(-30,-30,-30),164),
      rep(c(30,30,p[11]),164),
      rep(c(p[12:14]),164)),c(492,4,3))
tran <- matrix(c(0.16,0.29,0,0.55,
	0.17,0.3,0.4,0.13,
	0.23,0.31,0.22,0.24,
	0.27,0,0.34,0.39),ncol=4,byrow=T)
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	tvmu=mu4tvc,ptvmu=rep(0,14),iter=200))
p <- c(z$coef[1],-30,-30,30,30,30,-30,-30,z$coef[2:6],30,
	z$coef[7],-30,-30,-30,-30,-30,-30,z$coef[8],-30,z$coef[9],-30,-30,
	z$coef[10],-30,-30,-30,30,30,z$coef[11:14])
c(exp(p[seq(1,36,by=12)]),1)/(1+sum(exp(p[seq(1,36,by=12)])))
c(exp(p[seq(4,36,by=12)]),1)/(1+sum(exp(p[seq(4,36,by=12)])))
c(exp(p[seq(7,36,by=12)]),1)/(1+sum(exp(p[seq(7,36,by=12)])))
c(exp(p[seq(10,36,by=12)]),1)/(1+sum(exp(p[seq(10,36,by=12)])))

c(exp(p[seq(2,36,by=12)]),1)/(1+sum(exp(p[seq(2,36,by=12)])))
c(exp(p[seq(5,36,by=12)]),1)/(1+sum(exp(p[seq(5,36,by=12)])))
c(exp(p[seq(8,36,by=12)]),1)/(1+sum(exp(p[seq(8,36,by=12)])))
c(exp(p[seq(11,36,by=12)]),1)/(1+sum(exp(p[seq(11,36,by=12)])))

c(exp(p[seq(3,36,by=12)]),1)/(1+sum(exp(p[seq(3,36,by=12)])))
c(exp(p[seq(6,36,by=12)]),1)/(1+sum(exp(p[seq(6,36,by=12)])))
c(exp(p[seq(9,36,by=12)]),1)/(1+sum(exp(p[seq(9,36,by=12)])))
c(exp(p[seq(12,36,by=12)]),1)/(1+sum(exp(p[seq(12,36,by=12)])))

mu5tv <- function(p) array(c(rep(p[1:3],164),
      rep(p[4:6],164),
      rep(p[7:9],164),
      rep(p[10:12],164),
      rep(p[13:15],164),
      rep(p[16:18],164),
      rep(p[19:21],164),
      rep(p[22:24],164),
      rep(p[25:27],164),
      rep(p[28:30],164),
      rep(p[31:33],164),
      rep(p[34:36],164),
      rep(p[37:39],164),
      rep(p[40:42],164),
      rep(p[43:45],164)),c(492,5,3))
tran <- matrix(0.2,ncol=5,nrow=5)
diag(tran) <- 0.3
tran[1,2] <- tran[2,3] <- tran[3,2] <- tran[4,2] <- tran[5,2] <- 0.1
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	tvmu=mu5tv,ptvmu=rep(0,45),iter=200))
p <- c(z$coef)
c(exp(p[seq(1,45,by=15)]),1)/(1+sum(exp(p[seq(1,45,by=15)])))
c(exp(p[seq(4,45,by=15)]),1)/(1+sum(exp(p[seq(4,45,by=15)])))
c(exp(p[seq(7,45,by=15)]),1)/(1+sum(exp(p[seq(7,45,by=15)])))
c(exp(p[seq(10,45,by=15)]),1)/(1+sum(exp(p[seq(10,45,by=15)])))
c(exp(p[seq(13,45,by=15)]),1)/(1+sum(exp(p[seq(13,45,by=15)])))

c(exp(p[seq(2,45,by=15)]),1)/(1+sum(exp(p[seq(2,45,by=15)])))
c(exp(p[seq(5,45,by=15)]),1)/(1+sum(exp(p[seq(5,45,by=15)])))
c(exp(p[seq(8,45,by=15)]),1)/(1+sum(exp(p[seq(8,45,by=15)])))
c(exp(p[seq(11,45,by=15)]),1)/(1+sum(exp(p[seq(11,45,by=15)])))
c(exp(p[seq(14,45,by=15)]),1)/(1+sum(exp(p[seq(14,45,by=15)])))

c(exp(p[seq(3,45,by=15)]),1)/(1+sum(exp(p[seq(3,45,by=15)])))
c(exp(p[seq(6,45,by=15)]),1)/(1+sum(exp(p[seq(6,45,by=15)])))
c(exp(p[seq(9,45,by=15)]),1)/(1+sum(exp(p[seq(9,45,by=15)])))
c(exp(p[seq(12,45,by=15)]),1)/(1+sum(exp(p[seq(12,45,by=15)])))
c(exp(p[seq(15,45,by=15)]),1)/(1+sum(exp(p[seq(15,45,by=15)])))
mu5tvc <- function(p) array(c(rep(c(-30,p[1],-30),164),
      rep(c(p[2],-30,-30),164),
      rep(c(30,30,30),164),
      rep(c(p[3:5]),164),
      rep(c(p[6:8]),164),
      rep(p[9:11],164),
      rep(c(-30,p[12],-30),164),
      rep(c(-30,-30,-30),164),
      rep(c(p[13:15]),164),
      rep(c(p[16:18]),164),
      rep(p[19:21],164),
      rep(c(-30,-30,-30),164),
      rep(c(-30,-30,-30),164),
      rep(c(p[22:23],-30),164),
      rep(c(p[24],-30,-30),164)),c(492,5,3))
tran <- matrix(c(0.37,0.30,0.33,0,0,
	0.49,0.33,0,0.05,0.13,
	0.42,0,0.34,0.24,0,
	0,0.04,0,0.21,0.75,
	0,0.53,0,0.22,0.25),ncol=5,byrow=T)
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	tvmu=mu5tvc,ptvmu=rep(0,24),iter=200))
p <- c(-30,z$coef[1],-30,z$coef[2],-30,-30,30,30,30,z$coef[3:11],-30,
	z$coef[12],-30,-30,-30,-30,z$coef[13:21],-30,-30,-30,-30,-30,-30,
	z$coef[22:23],-30,z$coef[24],-30,-30)
c(exp(p[seq(1,45,by=15)]),1)/(1+sum(exp(p[seq(1,45,by=15)])))
c(exp(p[seq(4,45,by=15)]),1)/(1+sum(exp(p[seq(4,45,by=15)])))
c(exp(p[seq(7,45,by=15)]),1)/(1+sum(exp(p[seq(7,45,by=15)])))
c(exp(p[seq(10,45,by=15)]),1)/(1+sum(exp(p[seq(10,45,by=15)])))
c(exp(p[seq(13,45,by=15)]),1)/(1+sum(exp(p[seq(13,45,by=15)])))
c(exp(p[seq(2,45,by=15)]),1)/(1+sum(exp(p[seq(2,45,by=15)])))
c(exp(p[seq(5,45,by=15)]),1)/(1+sum(exp(p[seq(5,45,by=15)])))
c(exp(p[seq(8,45,by=15)]),1)/(1+sum(exp(p[seq(8,45,by=15)])))
c(exp(p[seq(11,45,by=15)]),1)/(1+sum(exp(p[seq(11,45,by=15)])))
c(exp(p[seq(14,45,by=15)]),1)/(1+sum(exp(p[seq(14,45,by=15)])))

c(exp(p[seq(3,45,by=15)]),1)/(1+sum(exp(p[seq(3,45,by=15)])))
c(exp(p[seq(6,45,by=15)]),1)/(1+sum(exp(p[seq(6,45,by=15)])))
c(exp(p[seq(9,45,by=15)]),1)/(1+sum(exp(p[seq(9,45,by=15)])))
c(exp(p[seq(12,45,by=15)]),1)/(1+sum(exp(p[seq(12,45,by=15)])))
c(exp(p[seq(15,45,by=15)]),1)/(1+sum(exp(p[seq(15,45,by=15)])))

mu5tvc <- function(p) array(c(rep(c(-30,-30,-30),164),
      rep(c(p[1],-30,p[2]),164),
      rep(c(p[3],30,p[4]),164),
      rep(c(30,30,30),164),
      rep(c(30,p[5],30),164),
      rep(p[6:8],164),
      rep(c(-30,p[9],-30),164),
      rep(c(p[10],-30,-30),164),
      rep(c(-30,-30,-30),164),
      rep(c(-30,-30,-30),164),
      rep(p[11:13],164),
      rep(c(-30,-30,-30),164),
      rep(c(p[14],-30,p[15]),164),
      rep(c(-30,-30,-30),164),
      rep(c(-30,p[16],-30),164)),c(492,5,3))
tran <- matrix(c(0.35,0.36,0,0.23,0.06,
	0.51,0.43,0.06,0,0,
	0,0.16,0.84,0,0,
	0.33,0,0,0.20,0.47,
	0.5,0.12,0,0,0.38),ncol=5,byrow=T)
print(z <- hidden(y[,gene],dist="mult",pgamma=tran,
	tvmu=mu5tvc,ptvmu=rep(0,16),iter=200))
p <- c(-30,-30,-30,z$coef[1],-30,z$coef[2:3],30,z$coef[4],30,30,30,30,
	z$coef[5],30,z$coef[6:8],-30,z$coef[9],-30,z$coef[10],rep(-30,8),
	z$coef[11:13],-30,-30,-30,z$coef[14],-30,z$coef[15],-30,-30,-30,-30,
	z$coef[16],-30)
c(exp(p[seq(1,45,by=15)]),1)/(1+sum(exp(p[seq(1,45,by=15)])))
c(exp(p[seq(4,45,by=15)]),1)/(1+sum(exp(p[seq(4,45,by=15)])))
c(exp(p[seq(7,45,by=15)]),1)/(1+sum(exp(p[seq(7,45,by=15)])))
c(exp(p[seq(10,45,by=15)]),1)/(1+sum(exp(p[seq(10,45,by=15)])))
c(exp(p[seq(13,45,by=15)]),1)/(1+sum(exp(p[seq(13,45,by=15)])))

c(exp(p[seq(2,45,by=15)]),1)/(1+sum(exp(p[seq(2,45,by=15)])))
c(exp(p[seq(5,45,by=15)]),1)/(1+sum(exp(p[seq(5,45,by=15)])))
c(exp(p[seq(8,45,by=15)]),1)/(1+sum(exp(p[seq(8,45,by=15)])))
c(exp(p[seq(11,45,by=15)]),1)/(1+sum(exp(p[seq(11,45,by=15)])))
c(exp(p[seq(14,45,by=15)]),1)/(1+sum(exp(p[seq(14,45,by=15)])))

c(exp(p[seq(3,45,by=15)]),1)/(1+sum(exp(p[seq(3,45,by=15)])))
c(exp(p[seq(6,45,by=15)]),1)/(1+sum(exp(p[seq(6,45,by=15)])))
c(exp(p[seq(9,45,by=15)]),1)/(1+sum(exp(p[seq(9,45,by=15)])))
c(exp(p[seq(12,45,by=15)]),1)/(1+sum(exp(p[seq(12,45,by=15)])))
c(exp(p[seq(15,45,by=15)]),1)/(1+sum(exp(p[seq(15,45,by=15)])))
